Index: orxonox/trunk/console/Makefile.am
===================================================================
--- orxonox/trunk/console/Makefile.am	(revision 2588)
+++ orxonox/trunk/console/Makefile.am	(revision 2589)
@@ -3,7 +3,6 @@
 
 bin_PROGRAMS=console
-console_SOURCES=orxonox_console.cc orxonox_console.h \
-		orxonox_console_entry.cc orxonox_console_entry.h \
-		orxonox_console_log.cc orxonox_console_log.h
+console_SOURCES=orxonox_console.cc orxonox_console_entry.cc orxonox_console_log.cc
+noinst_HEADERS=orxonox_console.h orxonox_console_entry.h orxonox_console_log.h
 
 #  uncomment the following if bencoder requires the math library
Index: orxonox/trunk/console/Makefile.in
===================================================================
--- orxonox/trunk/console/Makefile.in	(revision 2588)
+++ orxonox/trunk/console/Makefile.in	(revision 2589)
@@ -115,8 +115,6 @@
 #AM_LDFLAGS=`pkg-config --libs  gtk+-2.0`
 bin_PROGRAMS = console
-console_SOURCES = orxonox_console.cc orxonox_console.h \
-		orxonox_console_entry.cc orxonox_console_entry.h \
-		orxonox_console_log.cc orxonox_console_log.h
-
+console_SOURCES = orxonox_console.cc orxonox_console_entry.cc orxonox_console_log.cc
+noinst_HEADERS = orxonox_console.h orxonox_console_entry.h orxonox_console_log.h
 subdir = console
 ACLOCAL_M4 = $(top_srcdir)/aclocal.m4
@@ -145,10 +143,8 @@
 CXXLINK = $(CXXLD) $(AM_CXXFLAGS) $(CXXFLAGS) $(AM_LDFLAGS) $(LDFLAGS) \
 	-o $@
-COMPILE = $(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) \
-	$(CPPFLAGS) $(AM_CFLAGS) $(CFLAGS)
-CCLD = $(CC)
-LINK = $(CCLD) $(AM_CFLAGS) $(CFLAGS) $(AM_LDFLAGS) $(LDFLAGS) -o $@
 DIST_SOURCES = $(console_SOURCES)
-DIST_COMMON = $(srcdir)/Makefile.in Makefile.am
+HEADERS = $(noinst_HEADERS)
+
+DIST_COMMON = $(noinst_HEADERS) $(srcdir)/Makefile.in Makefile.am
 SOURCES = $(console_SOURCES)
 
@@ -310,5 +306,5 @@
 check-am: all-am
 check: check-am
-all-am: Makefile $(PROGRAMS)
+all-am: Makefile $(PROGRAMS) $(HEADERS)
 
 installdirs:
Index: orxonox/trunk/gui/Makefile.am
===================================================================
--- orxonox/trunk/gui/Makefile.am	(revision 2588)
+++ orxonox/trunk/gui/Makefile.am	(revision 2589)
@@ -3,11 +3,7 @@
 
 bin_PROGRAMS=gui
-gui_SOURCES=orxonox_gui.cc orxonox_gui.h \
-	orxonox_gui_video.cc orxonox_gui_video.h \
-	orxonox_gui_audio.cc orxonox_gui_audio.h \
-	orxonox_gui_exec.cc orxonox_gui_exec.h \
-	orxonox_gui_flags.cc orxonox_gui_flags.h \
-	orxonox_gui_banner.cc orxonox_gui_banner.h
-#orxonox_gui_file.cc 
+gui_SOURCES=orxonox_gui.cc orxonox_gui_video.cc	orxonox_gui_audio.cc orxonox_gui_exec.cc orxonox_gui_flags.cc orxonox_gui_banner.cc
+
+noinst_HEADERS=orxonox_gui.h orxonox_gui_video.h orxonox_gui_audio.h orxonox_gui_exec.h orxonox_gui_flags.h orxonox_gui_banner.h
 
 #  uncomment the following if bencoder requires the math library
Index: orxonox/trunk/gui/Makefile.in
===================================================================
--- orxonox/trunk/gui/Makefile.in	(revision 2588)
+++ orxonox/trunk/gui/Makefile.in	(revision 2589)
@@ -115,12 +115,7 @@
 #AM_LDFLAGS=`pkg-config --libs  gtk+-2.0`
 bin_PROGRAMS = gui
-gui_SOURCES = orxonox_gui.cc orxonox_gui.h \
-	orxonox_gui_video.cc orxonox_gui_video.h \
-	orxonox_gui_audio.cc orxonox_gui_audio.h \
-	orxonox_gui_exec.cc orxonox_gui_exec.h \
-	orxonox_gui_flags.cc orxonox_gui_flags.h \
-	orxonox_gui_banner.cc orxonox_gui_banner.h
-
-#orxonox_gui_file.cc 
+gui_SOURCES = orxonox_gui.cc orxonox_gui_video.cc	orxonox_gui_audio.cc orxonox_gui_exec.cc orxonox_gui_flags.cc orxonox_gui_banner.cc
+
+noinst_HEADERS = orxonox_gui.h orxonox_gui_video.h orxonox_gui_audio.h orxonox_gui_exec.h orxonox_gui_flags.h orxonox_gui_banner.h
 
 #  uncomment the following if bencoder requires the math library
@@ -163,10 +158,8 @@
 CXXLINK = $(CXXLD) $(AM_CXXFLAGS) $(CXXFLAGS) $(AM_LDFLAGS) $(LDFLAGS) \
 	-o $@
-COMPILE = $(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) \
-	$(CPPFLAGS) $(AM_CFLAGS) $(CFLAGS)
-CCLD = $(CC)
-LINK = $(CCLD) $(AM_CFLAGS) $(CFLAGS) $(AM_LDFLAGS) $(LDFLAGS) -o $@
 DIST_SOURCES = $(gui_SOURCES)
-DIST_COMMON = $(srcdir)/Makefile.in Makefile.am
+HEADERS = $(noinst_HEADERS)
+
+DIST_COMMON = $(noinst_HEADERS) $(srcdir)/Makefile.in Makefile.am
 SOURCES = $(gui_SOURCES)
 
@@ -331,5 +324,5 @@
 check-am: all-am
 check: check-am
-all-am: Makefile $(PROGRAMS)
+all-am: Makefile $(PROGRAMS) $(HEADERS)
 
 installdirs:
Index: orxonox/trunk/src/Makefile.am
===================================================================
--- orxonox/trunk/src/Makefile.am	(revision 2588)
+++ orxonox/trunk/src/Makefile.am	(revision 2589)
@@ -7,4 +7,7 @@
 bin_PROGRAMS=orxonox
 orxonox_SOURCES=orxonox.cc world.cc player.cc data_tank.cc world_entity.cc vector.cc camera.cc collision.cc command_node.cc ini_parser.cc keynames.cc track.cc base_entity.cc 
+
+noinst_HEADERS=ability.h data_tank.h npc.h stdincl.h ai.h environment.h orxonox.h synchronisable.h base_entity.h error.h player.h track.h camera.h ini_parser.h power_up.h vector.h collision.h keynames.h proto_class.h world.h command_node.h list.h shoot_laser.h world_entity.h coordinates.h message_structures.h shoot_rocket.h
+
 
 #  uncomment the following if bencoder requires the math library
Index: orxonox/trunk/src/Makefile.in
===================================================================
--- orxonox/trunk/src/Makefile.in	(revision 2588)
+++ orxonox/trunk/src/Makefile.in	(revision 2589)
@@ -118,4 +118,6 @@
 bin_PROGRAMS = orxonox
 orxonox_SOURCES = orxonox.cc world.cc player.cc data_tank.cc world_entity.cc vector.cc camera.cc collision.cc command_node.cc ini_parser.cc keynames.cc track.cc base_entity.cc 
+
+noinst_HEADERS = ability.h data_tank.h npc.h stdincl.h ai.h environment.h orxonox.h synchronisable.h base_entity.h error.h player.h track.h camera.h ini_parser.h power_up.h vector.h collision.h keynames.h proto_class.h world.h command_node.h list.h shoot_laser.h world_entity.h coordinates.h message_structures.h shoot_rocket.h
 subdir = src
 ACLOCAL_M4 = $(top_srcdir)/aclocal.m4
@@ -153,5 +155,8 @@
 	-o $@
 DIST_SOURCES = $(orxonox_SOURCES)
-DIST_COMMON = $(srcdir)/Makefile.in ChangeLog INSTALL Makefile.am
+HEADERS = $(noinst_HEADERS)
+
+DIST_COMMON = $(noinst_HEADERS) $(srcdir)/Makefile.in INSTALL \
+	Makefile.am
 SOURCES = $(orxonox_SOURCES)
 
@@ -323,5 +328,5 @@
 check-am: all-am
 check: check-am
-all-am: Makefile $(PROGRAMS)
+all-am: Makefile $(PROGRAMS) $(HEADERS)
 
 installdirs: