Index: /code/branches/buildsystem2/cmake/ConfigMSVC.cmake
===================================================================
--- /code/branches/buildsystem2/cmake/ConfigMSVC.cmake	(revision 2593)
+++ /code/branches/buildsystem2/cmake/ConfigMSVC.cmake	(revision 2594)
@@ -60,8 +60,6 @@
   SET(TCL_INCLUDE_PATH       ${MSVC_LIBRARY_DIR}/tcl-8.5.2/include)
   SET(TCL_LIBRARY            ${MSVC_LIBRARY_DIR}/tcl-8.5.2/lib/tcl85t.lib)
-  SET(TCL_FOUND TRUE)
   # Do some hacking to avoid "Tclsh not found" message
   SET(TCL_TCLSH              ${MSVC_LIBRARY_DIR}/tcl-8.5.2/lib/tcl85t.lib)
-  SET(TCL_TCLSH_FOUND TRUE)
   SET(ZLIB_INCLUDE_DIR       ${MSVC_LIBRARY_DIR}/zlib-1.2.3/include)
   SET(ZLIB_LIBRARY optimized ${MSVC_LIBRARY_DIR}/zlib-1.2.3/lib/zlib.lib
Index: /code/branches/buildsystem2/cmake/ConfigMinGW.cmake
===================================================================
--- /code/branches/buildsystem2/cmake/ConfigMinGW.cmake	(revision 2593)
+++ /code/branches/buildsystem2/cmake/ConfigMinGW.cmake	(revision 2594)
@@ -51,19 +51,21 @@
   SET(ENV{ALUTDIR}       "${MINGW_LIBRARY_DIR}/freealut-1.1.0")
   SET(ENV{OGGDIR}        "${MINGW_LIBRARY_DIR}/libogg-1.1.3;${MINGW_LIBRARY_DIR}/libogg-1.1.3/src/.libs")
-  SET(ENV{VORBISDIR}     "${MINGW_LIBRARY_DIR}/libogg-1.1.3;${MINGW_LIBRARY_DIR}/libvorbis-1.2.0/src/.libs")
+  SET(ENV{VORBISDIR}     "${MINGW_LIBRARY_DIR}/libvorbis-1.2.0;${MINGW_LIBRARY_DIR}/libvorbis-1.2.0/lib/.libs")
   SET(ENV{OPENALDIR}     "${MINGW_LIBRARY_DIR}/openal-0.0.8/common;${MINGW_LIBRARY_DIR}/openal-0.0.8/src/.libs")
   SET(ENV{LUA_DIR}       "${MINGW_LIBRARY_DIR}/lua-5.1.3")
   SET(ENV{OGRE_HOME}     "${MINGW_LIBRARY_DIR}/ogre/OgreMain;${MINGW_LIBRARY_DIR}/ogre/Samples/Common")
   SET(TCL_INCLUDE_PATH   "${MINGW_LIBRARY_DIR}/tcl8.5.2/generic")
-  SET(TCL_LIBRARY_PATH   "${MINGW_LIBRARY_DIR}/tcl8.5.2/win/tcl85.dll")
+  SET(TCL_LIBRARY        "${MINGW_LIBRARY_DIR}/tcl8.5.2/win/tcl85.dll")
+  # Do some hacking to avoid "Tclsh not found" message
+  SET(TCL_TCLSH          "${MINGW_LIBRARY_DIR}/tcl8.5.2/win/tcl85.dll")
   SET(ZLIB_INCLUDE_DIR   "${MINGW_LIBRARY_DIR}/zlib/include")
   SET(ZLIB_LIBRARY       "${MINGW_LIBRARY_DIR}/zlib/libzlib.a")
-  IF (NOT ENV{DXSDK_DIR})
+  IF ($ENV{DXSDK_DIR} STREQUAL "")
     SET(ENV{DXSDK_DIR} "${MINGW_LIBRARY_DIR}/DXSDK")
-  ENDIF (NOT ENV{DXSDK_DIR})
+  ENDIF ($ENV{DXSDK_DIR} STREQUAL "")
 
   # MINGW doesn't like the -fPIC flag, reconfigure flags
-  SET(CMAKE_C_FLAGS   "$ENV{CFLAGS}   ${ORXONOX_WARNING_FLAGS)")
-  SET(CMAKE_CXX_FLAGS "$ENV{CXXFLAGS} ${ORXONOX_WARNING_FLAGS)")
+  SET(CMAKE_C_FLAGS   "$ENV{CFLAGS}   ${ORXONOX_WARNING_FLAGS}")
+  SET(CMAKE_CXX_FLAGS "$ENV{CXXFLAGS} ${ORXONOX_WARNING_FLAGS}")
 
   # Also set the tolua working directory because lua.dll is not where tolua ia
Index: /code/branches/buildsystem2/cmake/FindCEGUI.cmake
===================================================================
--- /code/branches/buildsystem2/cmake/FindCEGUI.cmake	(revision 2593)
+++ /code/branches/buildsystem2/cmake/FindCEGUI.cmake	(revision 2594)
@@ -35,5 +35,5 @@
     /usr/local
     /usr
-    PATH_SUFFIXES lib
+    PATH_SUFFIXES lib bin
 )
 FIND_LIBRARY(CEGUI_LIBRARY_DEBUG
@@ -43,5 +43,5 @@
     /usr/local
     /usr
-    PATH_SUFFIXES lib
+    PATH_SUFFIXES lib bin
 )
 
Index: /code/branches/buildsystem2/cmake/FindDirectX.cmake
===================================================================
--- /code/branches/buildsystem2/cmake/FindDirectX.cmake	(revision 2593)
+++ /code/branches/buildsystem2/cmake/FindDirectX.cmake	(revision 2594)
@@ -29,5 +29,9 @@
   )
 
-  FIND_PACKAGE_HANDLE_STANDARD_ARGS(DirectX DEFAULT_MSG DirectX_INCLUDE_DIR DirectX_LIBRARY_1 DirectX_LIBRARY_2)
+  FIND_PACKAGE_HANDLE_STANDARD_ARGS(DirectX DEFAULT_MSG
+    DirectX_LIBRARY_1
+    DirectX_LIBRARY_2
+    DirectX_INCLUDE_DIR
+  )
 
   IF(DIRECTX_FOUND)
Index: /code/branches/buildsystem2/cmake/FindOGRE.cmake
===================================================================
--- /code/branches/buildsystem2/cmake/FindOGRE.cmake	(revision 2593)
+++ /code/branches/buildsystem2/cmake/FindOGRE.cmake	(revision 2594)
@@ -51,5 +51,5 @@
     SET(CMAKE_FIND_LIBRARY_SUFFIXES .dll)
 ENDIF(WIN32)
-SET(CMAKE_FIND_LIBRARY_PREFIXES_STORED ${CMAKE_FIND_LIBRARY_PREFIXES})
+SET(CMAKE_FIND_LIBRARY_PREFIXES_STORED "${CMAKE_FIND_LIBRARY_PREFIXES}")
 SET(CMAKE_FIND_LIBRARY_PREFIXES "")
 
Index: /code/branches/buildsystem2/cmake/FindOggVorbis.cmake
===================================================================
--- /code/branches/buildsystem2/cmake/FindOggVorbis.cmake	(revision 2593)
+++ /code/branches/buildsystem2/cmake/FindOggVorbis.cmake	(revision 2594)
@@ -71,8 +71,10 @@
   OGG_INCLUDE_DIR
 )
+SET(VORBIS_FIND_REQUIRED ON)
 FIND_PACKAGE_HANDLE_STANDARD_ARGS(VORBIS DEFAULT_MSG
   VORBIS_LIBRARY_OPTIMIZED
   VORBIS_INCLUDE_DIR
 )
+SET(VORBISFILE_FIND_REQUIRED ON)
 FIND_PACKAGE_HANDLE_STANDARD_ARGS(VORBISFILE DEFAULT_MSG
   VORBISFILE_LIBRARY_OPTIMIZED
Index: /code/branches/buildsystem2/src/ois/CMakeLists.txt
===================================================================
--- /code/branches/buildsystem2/src/ois/CMakeLists.txt	(revision 2593)
+++ /code/branches/buildsystem2/src/ois/CMakeLists.txt	(revision 2594)
@@ -1,4 +1,2 @@
-INCLUDE_DIRECTORIES(.)
-
 SET( OIS_SRC_FILES
   OISEffect.cpp