Index: /orxonox/trunk/gui/orxonox_gui.cc
===================================================================
--- /orxonox/trunk/gui/orxonox_gui.cc	(revision 2594)
+++ /orxonox/trunk/gui/orxonox_gui.cc	(revision 2595)
@@ -63,5 +63,5 @@
 
   banner = new OrxonoxGuiBanner();
-  windowBox->fill (banner->getEventBox());
+  windowBox->fill (banner->getWidget());
   
   Box* optionBox = new Box ('v');
@@ -70,17 +70,17 @@
 
   video = new OrxonoxGuiVideo ();
-  avBox->fill (video->getFrame ());
+  avBox->fill (video->getWidget ());
   audio = new OrxonoxGuiAudio ();
-  avBox->fill (audio->getFrame ());
+  avBox->fill (audio->getWidget ());
       
   optionBox->fill (avBox);
     
   exec = new OrxonoxGuiExec (orxonoxGUI);
-  optionBox->fill (exec->getFrame ());
+  optionBox->fill (exec->getWidget ());
 
   flags = new OrxonoxGuiFlags (orxonoxGUI);
 
 
-  optionBox->fill (flags->getFrame ());
+  optionBox->fill (flags->getWidget ());
   windowBox->fill (optionBox);
   
Index: /orxonox/trunk/gui/orxonox_gui.h
===================================================================
--- /orxonox/trunk/gui/orxonox_gui.h	(revision 2594)
+++ /orxonox/trunk/gui/orxonox_gui.h	(revision 2595)
@@ -43,5 +43,5 @@
   virtual void init(void);
   int is_option; //!< with this Paramenter one can set the IsOption type: -2:Container, -1: Box, 0: not an Option, 1: Bool-option, 2: int-option
-
+  enum option { containerType = -2, boxType = -1, nothingType = 0, boolType = 1, intType = 2}; //!< defines is_option states
   void connectSignal (char* event, gint (*signal)(GtkWidget*, GdkEvent*, void *));
   void connectSignal (char* event, gint (*signal)(GtkWidget*, Widget *));
Index: /orxonox/trunk/gui/orxonox_gui_audio.cc
===================================================================
--- /orxonox/trunk/gui/orxonox_gui_audio.cc	(revision 2594)
+++ /orxonox/trunk/gui/orxonox_gui_audio.cc	(revision 2595)
@@ -55,5 +55,5 @@
    \return Returns the Audio-frame
 */
-Frame* OrxonoxGuiAudio::getFrame ()
+Widget* OrxonoxGuiAudio::getWidget ()
 {
   return audioFrame;
Index: /orxonox/trunk/gui/orxonox_gui_audio.h
===================================================================
--- /orxonox/trunk/gui/orxonox_gui_audio.h	(revision 2594)
+++ /orxonox/trunk/gui/orxonox_gui_audio.h	(revision 2595)
@@ -22,5 +22,5 @@
   ~OrxonoxGuiAudio ();
   
-  Frame* getFrame ();
+  Widget* getWidget ();
 };
 #endif /* _ORXONOX_GUI_AUDIO_H */
Index: /orxonox/trunk/gui/orxonox_gui_banner.cc
===================================================================
--- /orxonox/trunk/gui/orxonox_gui_banner.cc	(revision 2594)
+++ /orxonox/trunk/gui/orxonox_gui_banner.cc	(revision 2595)
@@ -62,9 +62,14 @@
 	  logoWindow->connectSignal("delete_event", this, LogoWindowClose);
 	  logoEventBox = new EventBox();
+	  logoBox = new Box('v');
+	  logoLabel = new Label("OrxOnoX");
 	  logoImage = new Image("banner.xpm");
 	  logoEventBox->fill(logoImage);
+
+	  logoBox->fill(logoLabel);
+	  logoBox->fill(logoEventBox);
 	  logoEventBox->connectSignal("button_press_event",this,LogoWindowClose);
 
-	  logoWindow->fill (logoEventBox);
+	  logoWindow->fill (logoBox);
 	  
 	}
@@ -90,5 +95,5 @@
    \return The EventBox, that holds the Banner.
 */
-EventBox* OrxonoxGuiBanner::getEventBox ()
+Widget* OrxonoxGuiBanner::getWidget ()
 {
   return bannerEventBox;
Index: /orxonox/trunk/gui/orxonox_gui_banner.h
===================================================================
--- /orxonox/trunk/gui/orxonox_gui_banner.h	(revision 2594)
+++ /orxonox/trunk/gui/orxonox_gui_banner.h	(revision 2595)
@@ -14,4 +14,5 @@
 {
  private:
+  // the banner Frame
   Frame* bannerFrame;
   Box* bannerBox;
@@ -19,8 +20,12 @@
   Image* bannerImage;
   Label* bannerLabel;
+
+  // the logo Window
   Window* logoWindow;
   int logoWindowIsOpen;
   EventBox* logoEventBox;
+  Box* logoBox;
   Image* logoImage;
+  Label* logoLabel;
 
  public:
@@ -30,5 +35,5 @@
   void logoWindowNew();
   void logoWindowClose();
-  EventBox* getEventBox ();
+  Widget* getWidget ();
 };
 
Index: /orxonox/trunk/gui/orxonox_gui_exec.cc
===================================================================
--- /orxonox/trunk/gui/orxonox_gui_exec.cc	(revision 2594)
+++ /orxonox/trunk/gui/orxonox_gui_exec.cc	(revision 2595)
@@ -62,5 +62,5 @@
    \return Returns the Exec-frame
 */
-Frame* OrxonoxGuiExec::getFrame ()
+Widget* OrxonoxGuiExec::getWidget ()
 {
   return execFrame;
Index: /orxonox/trunk/gui/orxonox_gui_exec.h
===================================================================
--- /orxonox/trunk/gui/orxonox_gui_exec.h	(revision 2594)
+++ /orxonox/trunk/gui/orxonox_gui_exec.h	(revision 2595)
@@ -28,5 +28,5 @@
   ~OrxonoxGuiExec ();
   
-  Frame* getFrame ();
+  Widget* getWidget ();
   
   void setFilename (char* filename);
Index: /orxonox/trunk/gui/orxonox_gui_flags.cc
===================================================================
--- /orxonox/trunk/gui/orxonox_gui_flags.cc	(revision 2594)
+++ /orxonox/trunk/gui/orxonox_gui_flags.cc	(revision 2595)
@@ -50,5 +50,5 @@
    \returns Frame that holds the Flagtext.
 */
-Frame* OrxonoxGuiFlags::getFrame ()
+Widget* OrxonoxGuiFlags::getWidget ()
 {
   return flagsFrame;
Index: /orxonox/trunk/gui/orxonox_gui_flags.h
===================================================================
--- /orxonox/trunk/gui/orxonox_gui_flags.h	(revision 2594)
+++ /orxonox/trunk/gui/orxonox_gui_flags.h	(revision 2595)
@@ -26,5 +26,5 @@
   void OrxonoxGuiFlags::FlagsText(Widget* widget);
   
-  Frame* getFrame ();
+  Widget* getWidget ();
 };
 #endif /* _ORXONOX_GUI_FLAGS_H */
Index: /orxonox/trunk/gui/orxonox_gui_video.cc
===================================================================
--- /orxonox/trunk/gui/orxonox_gui_video.cc	(revision 2594)
+++ /orxonox/trunk/gui/orxonox_gui_video.cc	(revision 2595)
@@ -47,5 +47,5 @@
    \return Returns the Video-frame
 */
-Frame* OrxonoxGuiVideo::getFrame ()
+Widget* OrxonoxGuiVideo::getWidget ()
 {
   return videoFrame;
Index: /orxonox/trunk/gui/orxonox_gui_video.h
===================================================================
--- /orxonox/trunk/gui/orxonox_gui_video.h	(revision 2594)
+++ /orxonox/trunk/gui/orxonox_gui_video.h	(revision 2595)
@@ -20,5 +20,5 @@
   ~OrxonoxGuiVideo ();
   
-  Frame* getFrame ();
+  Widget* getWidget ();
 };
 #endif /* _ORXONOX_GUI_VIDEO_H */
Index: /orxonox/trunk/gui/rc
===================================================================
--- /orxonox/trunk/gui/rc	(revision 2594)
+++ /orxonox/trunk/gui/rc	(revision 2595)
@@ -122,4 +122,5 @@
 widget_class "GtkWindow" style "window"
 widget_class "GtkFrame" style "window"
+widget_class "Gtk*EventBox" style "window"
 widget_class "GtkDialog" style "window"
 widget_class "GtkFileSelection" style "window"